package cpcns.ldanganzhengli.lanjuan.controller;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import cpcns.base.common.User;
import cpcns.base.common.util.JsonWithJacksonUtils;
import cpcns.common.controller.commonController;
import cpcns.ldanganzhengli.lanjuan.model.LAnJuan;
import cpcns.ldanganzhengli.lanjuan.service.ILAnJuanService;
import cpcns.utils.CommStatic;
import cpcns.utils.DateUtil;
import cpcns.utils.Json;
import cpcns.utils.PagerVO;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import net.sf.json.JSONObject;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

@Controller
@RequestMapping({"/LAnJuan"})
public class LAnJuanController extends commonController {
  @Autowired
  private ILAnJuanService LAnJuanService;
  
  @RequestMapping({"/query.do"})
  public String execute(HttpServletRequest request, Model model) throws Exception {
    String menLei = request.getParameter("menLei");
    String yiJiaoPiCi = request.getParameter("yiJiaoPiCi");
    model.addAttribute("yiJiaoPiCi", yiJiaoPiCi);
    model.addAttribute("menLei", menLei);
    return "ldanganzhengli/lanjuan/LAnJuanList";
  }
  
  @RequestMapping({"/open.do"})
  public String open(HttpServletRequest request, HttpServletResponse response) {
    String hangBiaoShi = request.getParameter("hangBiaoShi");
    String menLei = getRequest().getParameter("menLei");
    LAnJuan cla = new LAnJuan();
    if (StringUtils.isNotBlank(hangBiaoShi)) {
      cla = (LAnJuan)this.LAnJuanService.getById(Integer.valueOf(Integer.parseInt(hangBiaoShi)));
      cla.setLjrq(DateUtil.getDate(cla.getLiJuanRiQi()));
      cla.setGdrq(DateUtil.getDate(cla.getGuiDangRiQi()));
    } else {
      cla.setMenLei(menLei);
    } 
    getRequest().setAttribute("anJuan", cla);
    return "ldanganzhengli/lanjuan/LAnJuanEdit";
  }
  
  @RequestMapping({"/toJuanNeiWenJian.do"})
  public String juanNeiWenJian() {
    String hangBiaoShi = getRequest().getParameter("hangBiaoShi");
    String menLei = getRequest().getParameter("menLei");
    getRequest().setAttribute("anJuanBiaoShi", hangBiaoShi);
    getRequest().setAttribute("menLei", menLei);
    return "ldanganzhengli/lanjuan/LJuanNeiWenJian";
  }
  
  @RequestMapping({"/getAll.do"})
  public String getAll(HttpServletRequest request, HttpServletResponse response) throws IOException {
    Enumeration<?> rnames = getRequest().getParameterNames();
    JSONObject jsonObject = new JSONObject();
    for (Enumeration<?> er = rnames; er.hasMoreElements(); ) {
      String thisName = er.nextElement().toString();
      String thisValue = getRequest().getParameter(thisName);
      jsonObject.put(thisName, thisValue);
    } 
    User user = getCurrentUser();
    StringBuffer sqlWhere = new StringBuffer();
    Iterator<String> iterator = jsonObject.keys();
    StringBuffer sqlSearch = new StringBuffer();
    sqlSearch.append("  1=1 ");
    String hbs_n1 = isJianDing();
    String hbs_n2 = isOrNotJieYue();
    if (StringUtils.isNotBlank(hbs_n1))
      sqlSearch.append(" and hangBiaoShi not in (" + hbs_n1 + ")"); 
    if (StringUtils.isNotBlank(hbs_n2))
      sqlSearch.append(" and hangBiaoShi not in (" + hbs_n2 + ")"); 
    sqlSearch.append(" and baoGuanQiXian !='D10'");
    while (iterator.hasNext()) {
      String key = iterator.next();
      String value = jsonObject.getString(key);
      if (value != null && !value.trim().equals("") && !key.equals("page") && !key.equals("rows") && !"order".equals(key) && !"sort".equals(key) && !"type".equals(key)) {
        if (key.contains("begin")) {
          key = key.substring(0, key.indexOf("begin"));
          sqlWhere.append(" and ").append(
              String.valueOf(key) + " >= " + "to_date('" + value + "','yyyy-mm-dd')");
          continue;
        } 
        if (key.contains("end")) {
          key = key.substring(0, key.indexOf("end"));
          sqlWhere.append(" and ").append(
              String.valueOf(key) + " <= " + "to_date('" + value + "','yyyy-mm-dd')");
          continue;
        } 
        if (!"server".equals(key) && !"table".equals(key)) {
          if (!key.contains("like")) {
            sqlWhere.append(" and ").append(String.valueOf(key) + " = '" + value + "'");
            continue;
          } 
          key = key.substring(0, key.indexOf("like"));
          sqlWhere.append(" and ").append(String.valueOf(key) + " like " + "'%" + value + "%'");
        } 
      } 
    } 
    if (sqlWhere.length() > 0)
      sqlSearch.append(sqlWhere.toString()); 
    String page = request.getParameter("page");
    String rows = request.getParameter("rows");
    int intPage = Integer.parseInt((page == null || page == "0") ? "0" : page);
    int number = Integer.parseInt((rows == null || rows == "0") ? "0" : rows);
    int start = (intPage - 1) * number;
    String type = (request.getParameter("type") == null) ? "D" : request.getParameter("type");
    String ml = (request.getParameter("menLei") == null) ? request.getParameter("menLeilike") : request.getParameter("menLei");
    String tb = CommStatic.getMenLeiToBiaoMing(ml).replaceAll("D_", String.valueOf(type) + "_");
    StringBuffer sql = new StringBuffer("select quanZongHao,zhuangTai,hangBiaoShi,biaoTi,xuHao,dangHao,guiDangBuMenMingCheng,liJuanDanWeiMingCheng,muLuHao,baoGuanQiXian,guiDangNianDu,miJi,fenShu,ruKuFangZhuangTai,fenLeiMingCheng,yiJiaoPiCi,menLei  from l_anjuan where  ");
    PagerVO pagevo = this.LAnJuanService.getAll(start, number, sql.toString(), sqlSearch.toString(), CommStatic.getOrderBy(request, "hangBiaoShi"), "l_anjuan");
    String jsonString = JsonWithJacksonUtils.getInstance().obj2Json(pagevo);
    jsonString = jsonString.replaceAll("HANGBIAOSHI", "hangBiaoShi").replaceAll("BIAOTI", "biaoTi").replaceAll("XUHAO", "xuHao").replaceAll("QUANZONGHAO", "quanZongHao").replaceAll("LIJUANDANWEIMINGCHENG", "liJuanDanWeiMingCheng")
      .replaceAll("DANGHAO", "dangHao").replaceAll("GUIDANGBUMENMINGCHENG", "guiDangBuMenMingCheng").replaceAll("MULUHAO", "muLuHao").replaceAll("FENLEIMINGCHENG", "fenLeiMingCheng")
      .replaceAll("BAOGUANQIXIAN", "baoGuanQiXian").replaceAll("GUIDANGNIANDU", "guiDangNianDu").replaceAll("MIJI", "miJi").replaceAll("LIJUANRIQI", "liJuanRiQi").replaceAll("MENLEI", "menLei")
      .replaceAll("FENSHU", "fenShu").replaceAll("RUKUFANGZHUANGTAI", "ruKuFangZhuangTai").replaceAll("ZHUANGTAI", "zhuangTai").replaceAll("YIJIAOPICI", "yiJiaoPiCi");
    write(response, jsonString);
    return null;
  }
  
  private String isJianDing() {
    StringBuffer sql_qx = new StringBuffer("select qx.jianDingBiaoShi from D_BaoGuanQiXianJianDing qx,D_JianDingFangAn fa where qx.guanLianBiaoShi=fa.hangBiaoShi and fa.jianDingZhuangTai=1");
    StringBuffer sql_gk = new StringBuffer("select gk.jianDingBiaoShi from D_WenJianMiJiJianDing gk,D_JianDingFangAn fa where gk.guanLianBiaoShi=fa.hangBiaoShi and fa.jianDingZhuangTai=1");
    StringBuffer retu = new StringBuffer();
    List<String> qx = this.LAnJuanService.getList(sql_qx.toString());
    if (qx != null && qx.size() > 0)
      for (int i = 0; i < qx.size(); i++) {
        if (StringUtils.isBlank(retu.toString())) {
          retu.append(qx.get(i));
        } else {
          retu.append("," + qx.get(i));
        } 
      }  
    List<String> gk = this.LAnJuanService.getList(sql_gk.toString());
    if (gk != null && gk.size() > 0)
      for (int i = 0; i < gk.size(); i++) {
        if (StringUtils.isBlank(retu.toString())) {
          retu.append(gk.get(i));
        } else {
          retu.append("," + gk.get(i));
        } 
      }  
    String ret = getJH(retu.toString());
    return ret;
  }
  
  private String isOrNotJieYue() {
    StringBuffer hangBiaoShi = new StringBuffer();
    String da = (new SimpleDateFormat("yyyy-MM-dd")).format(new Date());
    StringBuffer sql = new StringBuffer("select wj.guanLianBiaoShi from D_LiYongWenJian wj,D_LiYongShenQingDan sqd where wj.shenQingDanBiaoShi=sqd.hangBiaoShi and ((sqd.liYongFangShi=10 and sqd.yingHuanRiQi>=to_date('" + da + "','yyyy-mm-dd')) or (sqd.liYongFangShi=20 and wj.zhuangTai=1))");
    List<String> lis = this.LAnJuanService.getList(sql.toString());
    if (lis != null && lis.size() > 0)
      for (int i = 0; i < lis.size(); i++) {
        if (StringUtils.isBlank(hangBiaoShi.toString())) {
          hangBiaoShi.append(lis.get(i));
        } else {
          hangBiaoShi.append("," + lis.get(i));
        } 
      }  
    String ret = getJH(hangBiaoShi.toString());
    return ret;
  }
  
  private String getJH(String hangBiaoShi) {
    StringBuffer ret = new StringBuffer();
    if (StringUtils.isNotBlank(hangBiaoShi)) {
      StringBuffer sql_h = new StringBuffer("select distinct guanLianBiaoShi from D_WenJian where hangBiaoShi in (" + hangBiaoShi + ")");
      List<String> jh = this.LAnJuanService.getList(sql_h.toString());
      if (jh != null && jh.size() > 0)
        for (int i = 0; i < jh.size(); i++) {
          if (StringUtils.isBlank(ret.toString())) {
            ret.append(jh.get(i));
          } else {
            ret.append("," + jh.get(i));
          } 
        }  
    } 
    return ret.toString();
  }
  
  @RequestMapping({"/openDat.do"})
  @ResponseBody
  public String returnJos(HttpServletRequest request, HttpServletResponse response, Model model) {
    String hangBiaoShi = request.getParameter("hangBiaoShi");
    Map<String, Object> resultMap = new HashMap<>();
    resultMap.put("filePath", "");
    String jsonString = "";
    if (StringUtils.isNotBlank(hangBiaoShi)) {
      LAnJuan cla = (LAnJuan)this.LAnJuanService.getById(Integer.valueOf(Integer.parseInt(hangBiaoShi)));
      resultMap.put("filePath", cla);
    } 
    jsonString = Json.Map2Json(resultMap);
    return jsonString;
  }
}
